diff -r -u -U 26 pgadmin-rev7540/frm/frmEditGrid.cpp pgadmin-padenter/frm/frmEditGrid.cpp
--- pgadmin-rev7540/frm/frmEditGrid.cpp	2009-01-08 00:15:22.084000000 +0800
+++ pgadmin-padenter/frm/frmEditGrid.cpp	2009-01-08 00:21:31.053000000 +0800
@@ -788,66 +788,73 @@
         case WXK_RETURN:
         case WXK_NUMPAD_ENTER:
             // check for shift etc.
             if (event.ControlDown() || event.ShiftDown())
             {
                 // Inject a RETURN into the control
                 wxGridCellEditor *edit=sqlGrid->GetCellEditor(currow, curcol);
                 if (edit)
                 {
                     wxControl *ctl=edit->GetControl();
                     if (ctl)
                     {
                         wxTextCtrl *txt=wxDynamicCast(ctl, wxTextCtrl);
                         if (txt)
                         {
                             long from, to;
                             txt->GetSelection(&from, &to);
                             txt->Replace(from, to, END_OF_LINE);
                         }
                     }
                     edit->DecRef();
                 }
                 return;
             }
             else
             {
-                if (curcol == sqlGrid->GetNumberCols()-1)
+                if( keycode!=WXK_NUMPAD_ENTER )
                 {
-                    curcol=0;
-                    currow++;
-                    // locate first editable column
-                    while (sqlGrid->IsReadOnly(currow, curcol) && curcol < sqlGrid->GetNumberCols())
-                        curcol++;
-                    // next line is completely read-only
-                    if (curcol == sqlGrid->GetNumberCols())
-                        return;
+                    if (curcol == sqlGrid->GetNumberCols()-1)
+                    {
+                        curcol=0;
+                        currow++;
+                        // locate first editable column
+                        while (sqlGrid->IsReadOnly(currow, curcol) && curcol < sqlGrid->GetNumberCols())
+                            curcol++;
+                        // next line is completely read-only
+                        if (curcol == sqlGrid->GetNumberCols())
+                            return;
 
+                    }
+                    else
+                        curcol++;
+                }
+                else // ( keycode==WXK_NUMPAD_ENTER )
+                {
+                    currow++;
                 }
-                else
-                    curcol++;
 
                 OnSave(ev);
                 sqlGrid->SetGridCursor(currow, curcol);
     
                 return;
             }
 
         case WXK_TAB:
             if (event.ControlDown())
             {
                 wxTextCtrl *text = (wxTextCtrl *)sqlGrid->GetCellEditor(sqlGrid->GetGridCursorRow(), sqlGrid->GetGridCursorCol())->GetControl();
                 if (text)
                     text->WriteText(wxT("\t"));
                 return;
             }
 
             break;
 
         default:
             if (sqlGrid->IsEditable() && keycode >= WXK_SPACE && keycode < WXK_START)
             {
                 if (sqlGrid->IsCurrentCellReadOnly())
                     return;
 
                 toolBar->EnableTool(MNU_SAVE, true);
                 toolBar->EnableTool(MNU_UNDO, true);
